class com.cintegrity.Lib.Exception.ExceptionStack:
  define private variable cob_ExceptionStackImpl as class com.cintegrity.Lib.Exception.ExceptionStackImpl no-undo.
  /* ----------------------------------------------------------------------- */
  constructor public ExceptionStack():
    define variable mob_SessionObject as PROGRESS.lang.OBJECT no-undo.
    define variable mch_ObjectName as character no-undo.
    mob_SessionObject = session:first-object.
    FIND-CONTEXT:
    do while valid-object( mob_SessionObject ):
      mch_ObjectName = mob_SessionObject:getClass():TypeName.
      if mch_ObjectName eq "com.cintegrity.Lib.Exception.ExceptionStackImpl"
      then do:
        cob_ExceptionStackImpl = cast( mob_SessionObject, "com.cintegrity.Lib.Exception.ExceptionStackImpl" ).
        leave FIND-CONTEXT.
      end.
      mob_SessionObject = mob_SessionObject:next-sibling.
    end.
    if not valid-object( cob_ExceptionStackImpl )
    then do:
      cob_ExceptionStackImpl = new com.cintegrity.Lib.Exception.ExceptionStackImpl().
    end.
    cob_ExceptionStackImpl:addReference().
  end constructor.
  /* ----------------------------------------------------------------------- */
  destructor public ExceptionStack():
    cob_ExceptionStackImpl:dropReference().
    if cob_ExceptionStackImpl:numReferences() eq 0
    then delete object cob_ExceptionStackImpl.
  end destructor.
  /* ----------------------------------------------------------------------- */
  method public void pushException(
      input imin_ExceptionNumber as integer,
      input imin_ExceptionSeverity as integer,
      input imch_Arguments as character
      ):
    cob_ExceptionStackImpl:pushException(
        imin_ExceptionNumber,
        imin_ExceptionSeverity,
        imch_Arguments
        ).
  end method.
  /* ----------------------------------------------------------------------- */
  method public void trace(
      input imch_TraceMessage as character
      ):
    cob_ExceptionStackImpl:trace( imch_TraceMessage ).
  end method.
  /* ----------------------------------------------------------------------- */
  method public character popException(
      input imin_MinSeverity as integer
      ):
    return cob_ExceptionStackImpl:popException( imin_MinSeverity ).
  end method.
  /* ----------------------------------------------------------------------- */
  method public void dropException(
      input imin_MinSeverity as integer
      ):
    cob_ExceptionStackImpl:dropException( imin_MinSeverity ).
  end method.
  /* ----------------------------------------------------------------------- */
  method public integer getExceptionNo(
      input imin_MinSeverity as integer,
      input imin_Count as integer
      ):
    return cob_ExceptionStackImpl:getExceptionNo( imin_MinSeverity, imin_Count ).
  end method.
  /* ----------------------------------------------------------------------- */
  method public integer numExceptions(
      input imin_MinSeverity as integer
      ):
    return cob_ExceptionStackImpl:numExceptions( imin_MinSeverity ).
  end method.
  /* ----------------------------------------------------------------------- */
  method public void clearExceptions():
    cob_ExceptionStackImpl:clearExceptions().
  end method.
  /* ----------------------------------------------------------------------- */
  method public void setDebug():
    cob_ExceptionStackImpl:setDebug().
  end method.
  /* ----------------------------------------------------------------------- */
  method public void unsetDebug():
    cob_ExceptionStackImpl:unsetDebug().
  end method.
  /* ----------------------------------------------------------------------- */
  method public logical inDebug():
    return cob_ExceptionStackImpl:inDebug().
  end method.
  /* ----------------------------------------------------------------------- */
  method public longchar toLongString(
      input imin_Severity as integer
      ):
    return cob_ExceptionStackImpl:toLongString( imin_Severity ).
  end method.
  /* ----------------------------------------------------------------------- */
  method public longchar writeExternal():
    return cob_ExceptionStackImpl:writeExternal().
  end method.
  /* ----------------------------------------------------------------------- */
end class.
